set tez.queue.name=${TEZ_QUEUE}; 
truncate table ${DBNAME_WRK_PROD}.f_tr_sms_detallada_prev;

DROP TABLE IF EXISTS ${DBNAME_WRK_PROD}.altamira_trafico_sms_movil_pospago_fp_temp1;
create table ${DBNAME_WRK_PROD}.altamira_trafico_sms_movil_pospago_fp_temp1 as 
select
	t0.Ani_CD,
	t0.Fecha_Mensaje_FH,
	t0.ANI_DESTINO_CD AS Ani_Otro_CD,
	t0.Tipo_Trafico_CD,	
	CASE WHEN t0.Costo_Llamada_EURO_MO IS NOT NULL THEN Costo_Llamada_EURO_MO ELSE 0 END Costo_Llamada_EURO_MO, 
	CAST(0 AS DECIMAL(18,4)) AS Importe_Inicial_MO,
	CAST(0 AS DECIMAL(18,4)) AS Importe_Abono_MO,
	CAST(0 AS DECIMAL(18,4)) AS Importe_Recarga_MO,
	CAST(0 AS DECIMAL(18,4)) AS Importe_Promocion_MO,
	CAST(0 AS DECIMAL(18,4)) AS Importe_Bolsa5_MO,
	CAST(0 AS DECIMAL(18,4)) AS Importe_Bolsa6_MO,
	CAST(0 AS DECIMAL(18,4)) AS Importe_No_Cargado_MO,
	CAST(0 AS DECIMAL(18,4)) AS Importe_IVA_MO,
	CAST(NULL AS string) AS Tipo_Destino_Ext_CD,
	t0.Indicador_Roaming_CD,
	cast(t0.Operadora_CD as string) Operadora_CD,
	CAST(NULL AS string) AS Recibido_TLF_Red_CD,
	t0.CID_CD,
	CAST(NULL AS string) AS Identificador_Archivo_CD,
	CAST(NULL AS string) AS Tipo_Llamada_CD,
	cast(t0.clase_tarifa_mo as string) AS Clase_Tarifa_CD,
	CAST(NULL AS string) AS Tribu_CD,
	t0.Plan_Tarifario_CD,
	CAST(0 AS DECIMAL(18,4)) AS Deuda_MO,
	t0.Tipo_Evento_CD,
	t0.nombre_extractor_tx as Nombre_Archivo_DE,
	(case when t0.Indicador_Roaming_CD = "RMITNCL" then 1 else 2 end) as Roaming_FL,
	CAST(from_unixtime(UNIX_TIMESTAMP(t0.fecha_mensaje_fh,'yyyy-MM-dd HH:mm:s'),'yyyyMM') as int) as Anio_Mes_NR,
	cast(to_date(from_unixtime(UNIX_TIMESTAMP(t0.Fecha_Mensaje_FH,'yyyyMMdd'))) as date) as fecha_inicio_mensaje_id,
	ROW_NUMBER() over (PARTITION BY 
	t0.Ani_CD,
	t0.Fecha_Mensaje_FH,
	t0.ANI_DESTINO_CD,
	t0.Tipo_Trafico_CD,
	t0.Costo_Llamada_EURO_MO,
	t0.Indicador_Roaming_CD,
	t0.Operadora_CD,
	t0.CID_CD,
	t0.clase_tarifa_mo,
	t0.Plan_Tarifario_CD,
	t0.Tipo_Evento_CD,
	t0.nombre_extractor_tx) as r_number
from ${DBNAME_TRAFICO}.altamira_trafico_sms_movil_pospago_fp t0
LEFT JOIN ${DBNAME_EDW_PROD_LOG}.dimensional_list_nombre_extractor t1 on t0.nombre_extractor_tx = t1.nombre_extractor_tx and mode_name ='sms'  
where t1.nombre_extractor_tx IS NULL AND fecha = ${CURRENT_DATE_N};


DROP TABLE IF EXISTS ${DBNAME_WRK_PROD}.altamira_trafico_sms_movil_fp_temp1;
create table ${DBNAME_WRK_PROD}.altamira_trafico_sms_movil_fp_temp1 as 
select
	t0.Ani_CD,
	t0.Fecha_Mensaje_FH,
	t0.ANI_DESTINO_CD AS Ani_Otro_CD,
	t0.Tipo_Trafico_CD,
	CASE WHEN t0.Costo_Llamada_EURO_MO IS NOT NULL THEN Costo_Llamada_EURO_MO ELSE 0 END AS Costo_Llamada_EURO_MO,
	CASE WHEN t0.Importe_Inicial_MO IS NOT NULL THEN Importe_Inicial_MO ELSE 0 END AS Importe_Inicial_MO,
	CASE WHEN t0.Importe_Abono_MO IS NOT NULL THEN Importe_Abono_MO ELSE 0 END AS Importe_Abono_MO,
	CASE WHEN t0.Importe_Recarga_MO IS NOT NULL THEN Importe_Recarga_MO ELSE 0 END AS Importe_Recarga_MO,
	CASE WHEN t0.Importe_Promocion_MO IS NOT NULL THEN Importe_Promocion_MO ELSE 0 END AS Importe_Promocion_MO,
	CASE WHEN t0.Importe_Bolsa5_MO IS NOT NULL THEN Importe_Bolsa5_MO ELSE 0 END AS Importe_Bolsa5_MO,
	CASE WHEN t0.Importe_Bolsa6_MO IS NOT NULL THEN Importe_Bolsa6_MO ELSE 0 END AS Importe_Bolsa6_MO,
	CASE WHEN t0.Importe_No_Cargado_MO IS NOT NULL THEN Importe_No_Cargado_MO ELSE 0 END AS Importe_No_Cargado_MO,
	CASE WHEN t0.Importe_IVA_MO IS NOT NULL THEN Importe_IVA_MO ELSE 0 END AS Importe_IVA_MO,
	t0.Tipo_Destino_Ext_CD,
	t0.Indicador_Roaming_CD,
	cast(t0.Operadora_CD as string) Operadora_CD,
	t0.Recibido_TLF_Red_CD,
	t0.CID_CD,
	cast(t0.Identificador_Archivo_CD as string) Identificador_Archivo_CD,
	t0.Tipo_Llamada_CD,
	cast(t0.clase_tarifa_mo as string) AS Clase_Tarifa_CD,
	cast(t0.Tribu_CD as string) Tribu_CD,
	t0.Plan_Tarifario_CD,
	CASE WHEN t0.Deuda_MO IS NOT NULL THEN Deuda_MO ELSE 0 END AS Deuda_MO, 
	CAST(NULL AS string) AS Tipo_Evento_CD,
	t0.nombre_extractor_tx as Nombre_Archivo_DE,
	(case when t0.Indicador_Roaming_CD = "RMITNCL" then 1 else 2 end) as Roaming_FL,
	CAST(date_format(t0.fecha_mensaje_fh,'YYYYMM') AS INT) as Anio_Mes_NR,
	cast(to_date(from_unixtime(UNIX_TIMESTAMP(t0.Fecha_Mensaje_FH,'yyyyMMdd'))) as date) as fecha_inicio_mensaje_id,
	ROW_NUMBER() over (PARTITION BY 
	t0.Ani_CD,
	t0.Fecha_Mensaje_FH,
	t0.ANI_DESTINO_CD,
	t0.Tipo_Trafico_CD,
	t0.Costo_Llamada_EURO_MO,
	t0.Importe_Inicial_MO,
	t0.Importe_Abono_MO,
	t0.Importe_Recarga_MO,
	t0.Importe_Promocion_MO,
	t0.Importe_Bolsa5_MO,
	t0.Importe_Bolsa6_MO,
	t0.Importe_No_Cargado_MO,
	t0.Importe_IVA_MO,
	t0.Tipo_Destino_Ext_CD,
	t0.Indicador_Roaming_CD,
	t0.Operadora_CD,
	t0.Recibido_TLF_Red_CD,
	t0.CID_CD,
	t0.Identificador_Archivo_CD,
	t0.Tipo_Llamada_CD,
	t0.clase_tarifa_mo,
	t0.Tribu_CD,
	t0.Plan_Tarifario_CD,
	t0.Deuda_MO,
	t0.nombre_extractor_tx) as r_number
from ${DBNAME_TRAFICO}.altamira_trafico_sms_movil_fp t0
LEFT JOIN ${DBNAME_EDW_PROD_LOG}.dimensional_list_nombre_extractor t1 on t0.nombre_extractor_tx = t1.nombre_extractor_tx and mode_name ='sms'  
where t1.nombre_extractor_tx IS NULL AND fecha = ${CURRENT_DATE_N};

---insert 

insert into ${DBNAME_WRK_PROD}.f_tr_sms_detallada_prev
select 
	Ani_CD,
	Fecha_Mensaje_FH,
	Ani_Otro_CD,
	Tipo_Trafico_CD,
	Costo_Llamada_EURO_MO,
	Importe_Inicial_MO,
	Importe_Abono_MO,
	Importe_Recarga_MO,
	Importe_Promocion_MO,
	Importe_Bolsa5_MO,
	Importe_Bolsa6_MO,
	Importe_No_Cargado_MO,
	Importe_IVA_MO,
	Tipo_Destino_Ext_CD,
	Indicador_Roaming_CD,
	Operadora_CD,
	Recibido_TLF_Red_CD,
	CID_CD,
	Identificador_Archivo_CD,
	Tipo_Llamada_CD,
	Clase_Tarifa_CD,
	Tribu_CD,
	Plan_Tarifario_CD,
	Deuda_MO,
	Tipo_Evento_CD,
	Nombre_Archivo_DE,
	Roaming_FL,
	Anio_Mes_NR,
	fecha_inicio_mensaje_id
from ${DBNAME_WRK_PROD}.altamira_trafico_sms_movil_pospago_fp_temp1
where r_number = 1 

UNION ALL

select 
	Ani_CD,
	Fecha_Mensaje_FH,
	Ani_Otro_CD,
	Tipo_Trafico_CD,
	Costo_Llamada_EURO_MO,
	Importe_Inicial_MO,
	Importe_Abono_MO,
	Importe_Recarga_MO,
	Importe_Promocion_MO,
	Importe_Bolsa5_MO,
	Importe_Bolsa6_MO,
	Importe_No_Cargado_MO,
	Importe_IVA_MO,
	Tipo_Destino_Ext_CD,
	Indicador_Roaming_CD,
	Operadora_CD,
	Recibido_TLF_Red_CD,
	CID_CD,
	Identificador_Archivo_CD,
	Tipo_Llamada_CD,
	Clase_Tarifa_CD,
	Tribu_CD,
	Plan_Tarifario_CD,
	Deuda_MO,
	Tipo_Evento_CD,
	Nombre_Archivo_DE,
	Roaming_FL,
	Anio_Mes_NR,
	fecha_inicio_mensaje_id
from ${DBNAME_WRK_PROD}.altamira_trafico_sms_movil_fp_temp1
where r_number = 1 

UNION ALL

SELECT
	Ani_CD,
	Fecha_Mensaje_FH,
	Ani_Otro_CD,
	Tipo_Trafico_CD,
	Costo_Llamada_EURO_MO,
	Importe_Inicial_MO,
	Importe_Abono_MO,
	Importe_Recarga_MO,
	Importe_Promocion_MO,
	Importe_Bolsa5_MO,
	Importe_Bolsa6_MO,
	Importe_No_Cargado_MO,
	Importe_IVA_MO,
	Tipo_Destino_Ext_CD,
	Indicador_Roaming_CD,
	Operadora_CD,
	Recibido_TLF_Red_CD,
	CID_CD,
	Identificador_Archivo_CD,
	Tipo_Llamada_CD,
	Clase_Tarifa_CD,
	Tribu_CD,
	Plan_Tarifario_CD,
	Deuda_MO,
	Tipo_Evento_CD,
	Nombre_Archivo_DE,
	Roaming_FL,
	Anio_Mes_NR,
	fecha_inicio_mensaje_id
FROM 	
${DBNAME_EDW}.f_tr_sms_detallada_reinyect;